#ifndef __IDT_H__
#define __IDT_H__

#include <asm/types.h>
#include <asm/selector.h>

#define GATE_CALL	0x4
#define GATE_TASK	0x5
#define GATE_INTERRUPT	0xe	/* 386 int gate */
				/*this one masks further interrupts ?*/
#define GATE_TRAP	0xf	/* 386 trap gate */

#define GATE_PRESENT	(1<<7)

#define SET_IDT_ENTRY(tab,type,index,proc)	{ \
		tab[index].off16 = (u32) &proc; \
		tab[index].sel = KERNEL_CODE; \
		tab[index].reserved = 0; \
		tab[index].flags = GATE_PRESENT | type; \
		tab[index].off32 = ((u32) &proc) >> 16; \
	}

typedef struct idt_entry {
	u16 off16;			/* offset 0-15 */
	u16 sel;			/* segment selector */
	u8 reserved;			/* must be zero ! */
	u8 flags;			/* use macros */
	u16 off32;			/* offset 16-31 */
} idt_entry_t;


void init_idt(void);

#endif /*__IDT_H__*/
