#ifndef __PRINTK_H__
#define __PRINTK_H__

/* mode 0x07 - 80x25 color */
#define SCREEN			0xb8000
#define VGA_CRTCBASE		0x3d0
#define VGA_INDEX		(VGA_CRTCBASE+4)
#define VGA_DATA		(VGA_INDEX+1)

#define LINES	25
#define COLS	80

void puts(const char *str);
int printk(const char *fmt, ...);

void init_vga(void);

#define FG_BLACK	0x00
#define FG_BLUE		0x01
#define FG_GREEN	0x02
#define FG_CYAN		0x03
#define FG_RED		0x04
#define FG_MAGENTA	0x05
#define FG_BROWN	0x06
#define FG_GRAY		0x07
#define FG_DGRAY	0x08	/* dark gray */
#define FG_LBLUE	0x09	/* light blue and so on... */
#define FG_LGREEN	0x0a
#define FG_LCYAN	0x0b
#define FG_LBROWN	0x0c
#define FG_LMAGENTA	0x0d
#define FG_YELLOW	0x0e
#define FG_WHITE	0x0f

#define BG_BLACK	0x00
#define BG_BLUE		0x10
#define BG_GREEN	0x20
#define BG_CYAN		0x30
#define BG_RED		0x40
#define BG_MAGENTA	0x50
#define BG_BROWN	0x60
#define BG_GRAY		0x70
#define BG_BLINK	0x80	/* the text blinks, not background :) */

#endif /*__PRINTK_H__*/
