#ifndef __TSS_H__
#define __TSS_H__

#include <asm/types.h>

typedef struct tss {
	u16	previous_tss, reserved0;
	u32	esp0;
	u16	ss0, reserved1;
	u32	esp1;
	u16	ss1, reserved2;
	u32	esp2;
	u16	ss2, reserved3;
	/* for practical reasons define as pointer to array of pointers */
	/* but it's 4byte long pointer, this must be guaranteed */
	u32	*cr3;			/* CR3 - page directory pointer */
	u32	eip;
	u32	eflags;
	u32	eax, ecx, edx, ebx, esp, ebp, esi, edi;
	u16	es, reserved4;
	u16	cs, reserved5;
	u16	ss, reserved6;
	u16	ds, reserved7;
	u16	fs, reserved8;
	u16	gs, reserved9;
	u16	ldt, reserved10;
	u16	reserved11, iomap_base;
} tss_t;

#endif /*__TSS_H__*/
