/*
	here are low-level entries for exceptions
	feeding the main handler with all possible info
	
	but double fault should be TASK GATE (therefore not using this)
*/

		.extern exception	/* handler for all exceptions */

#define SEL_ONLY	/* only selectors */
#include <asm/selector.h>
#define DATA_SEL	KERNEL_DATA		/* all handlers in here */

/* macro for defining exception handler entry (faked error code) */
#define EXCEPTION(n)	\
		.global exception_##n	;\
		.align	4		;\
	exception_##n:			;\
		pushl	$0xdeadc0de	/* no error code :) */	;\
		pushal			/*eax, ecx, edx, ebx, original esp, ebp, esi, edi*/;\
		addl	$4, 12(%esp)	/* correct saved esp */	;\
		movl	$0x##n, %edx	/* exception number */	;\
		jmp	exception_all

/* exception with error code */
#define EXCEPTIONe(n)	\
		.global exception_##n	;\
		.align	4		;\
	exception_##n:			;\
		pushal			/*eax, ecx, edx, ebx, original esp, ebp, esi, edi*/;\
		movl	$0x##n, %edx	/* exception number */	;\
		jmp	exception_all


	exception_all:
		movl	32(%esp), %ecx	/* error code */
		movl	36(%esp), %edi	/* eip */
		movl	40(%esp), %esi	/* cs */

		pushl	%ss
		pushl	%gs
		pushl	%fs
		pushl	%es
		pushl	%ds

		pushl	64(%esp)	/* EFLAGS */

		movl	%cr2, %eax
		pushl	%eax		/* store CR2 too */

		/* were we transfered from lower privilege level? */
		movl	%ds, %ebx
		andl	$3, %ebx	/* do not mess with ebx now */

		movl	$DATA_SEL, %eax
		movl	%eax, %ds
		movl	%eax, %es

		/* push function arguments */
		pushl	%esp		/* struct regdump pointer */
		pushl	%edx		/* push exception number */
		pushl	%esi		/* cs */
		pushl	%edi		/* eip */
		pushl	%ecx		/* push error code */

		/* get real ss:esp */
		cmpl	$0,%ebx
		je	1f
		/* magic? :) */
		pushl	100(%esp)
		pushl	100(%esp)
		jmp	2f
	1:	/* push nothing, we already have them in regdump */
		pushl	$0
		pushl	$0
	2:

		call	exception	/* call the handler */
		addl	$36, %esp	/* get rid of garbage :) */

		popl	%ds
		popl	%es
		addl	$12, %esp	/* ss, gs, fs are not changed */
		popal

		addl	$4, %esp	/* pop error code */
		iret			/* and get out */

/* now we define all the handler entries (0x00-0x1f) */
	EXCEPTION(00)
	EXCEPTION(01)
	EXCEPTION(02)
	EXCEPTION(03)
	EXCEPTION(04)
	EXCEPTION(05)
	EXCEPTION(06)
	EXCEPTION(07)
	EXCEPTIONe(08)
	EXCEPTION(09)
	EXCEPTIONe(0A)
	EXCEPTIONe(0B)
	EXCEPTIONe(0C)
	EXCEPTIONe(0D)
	EXCEPTIONe(0E)
	EXCEPTION(0F)
	EXCEPTION(10)
	EXCEPTION(11)
	EXCEPTION(12)
	EXCEPTION(13)
	EXCEPTION(14)
	EXCEPTION(15)
	EXCEPTION(16)
	EXCEPTION(17)
	EXCEPTION(18)
	EXCEPTION(19)
	EXCEPTION(1A)
	EXCEPTION(1B)
	EXCEPTION(1C)
	EXCEPTION(1D)
	EXCEPTION(1E)
	EXCEPTION(1F)
