#include <asm/idt.h>
#include <asm/printk.h>
#include <asm/io.h>

void init_idt(void)
{
	extern struct idt_entry idt[256];
	extern void timer,ignore_int;

/*system int is TRAP with DPL=3, the only one allowed to call from user space
and debug stuff ints too*/
#define SET_EXCEPTION_HANDLER(n,dpl)	{				\
		extern void exception_##n ;				\
		SET_IDT_ENTRY(idt, GATE_TRAP | (dpl<<5), 0x##n, exception_##n );\
	}
#define SET_EXCEPTION(n)	SET_EXCEPTION_HANDLER(n,0)
#define SET_EXCEPTION_USER(n)	SET_EXCEPTION_HANDLER(n,3)

	SET_EXCEPTION(00)
	SET_EXCEPTION(01)	//intr DEBUG			WHY??
	SET_EXCEPTION(02)	//intr NMI			WHY??
	SET_EXCEPTION_USER(03)	//sys intr			WHY??
	SET_EXCEPTION_USER(04)	//sys trap (like system calls)
	SET_EXCEPTION_USER(05)	//sys trap (like system calls)
	SET_EXCEPTION(06)
	SET_EXCEPTION(07)
	SET_EXCEPTION(08)	//task! DOUBLE FAULT
	SET_EXCEPTION(09)
	SET_EXCEPTION(0A)
	SET_EXCEPTION(0B)
	SET_EXCEPTION(0C)
	SET_EXCEPTION(0D)
	SET_EXCEPTION(0E)	//intr PG FAULT - WHY?? we can't be interrupted?
	SET_EXCEPTION(0F)
	SET_EXCEPTION(10)
	SET_EXCEPTION(11)
	SET_EXCEPTION(12)
	SET_EXCEPTION(13)
	SET_EXCEPTION(14)
	SET_EXCEPTION(15)
	SET_EXCEPTION(16)
	SET_EXCEPTION(17)
	SET_EXCEPTION(18)
	SET_EXCEPTION(19)
	SET_EXCEPTION(1A)
	SET_EXCEPTION(1B)
	SET_EXCEPTION(1C)
	SET_EXCEPTION(1D)
	SET_EXCEPTION(1E)
	SET_EXCEPTION(1F)

	/* set all other interrupts to ingnoring handler first */
	for (int i=0x20; i < 0xff; i++)
		SET_IDT_ENTRY(idt, GATE_INTERRUPT, i, ignore_int);
	
/*******DEBUGGING UNUSED IRQ (skip timer and specific keyborad hanler)*/
extern void irq;
	for (int i=0x22; i< 0x30; i++)
		SET_IDT_ENTRY(idt, GATE_INTERRUPT, i, irq);
	/*we're handling all so enable all*/
	outb(0, 0xA1);
	outb(0, 0x21);
/*********************************************************************/

	/* now set more advanced interrupt hanlers :) */
	SET_IDT_ENTRY(idt, GATE_INTERRUPT, 0x20, timer);
	outb(inb_p(0x21)&(~0x01), 0x21);	/* unmask IRQ0 */

/*///TODO*/
//keyb int 1 - TRAP
	extern void keyboard;
	SET_IDT_ENTRY(idt, GATE_TRAP, 0x21, keyboard);
	outb(inb_p(0x21)&(~0x02), 0x21);	/* unmask IRQ1 */

/*///TODO*/
extern void irq8;
/*INTERRUPT GATE?*/
	SET_IDT_ENTRY(idt, GATE_INTERRUPT, 0x28, irq8);
	outb(inb_p(0xA1)&(~0x01), 0xA1);	/* unmask IRQ8 */

	/* don't forget to enable the slave PIC (cascade IRQ) */
	outb(inb_p(0x21)&(~0x04), 0x21);	/* enable IRQ2 - slave PIC */

	extern void load_idt(void);
	load_idt();	/* load IDTR, then we can enable interrupts */
}

void irq_c()
{
	printk("unknown IRQ!\n");
}
