#define SEL_ONLY	/* only selectors */
#include <asm/selector.h>

		.text
		.globl	timer, ticks
		
		.align 4
	timer:
		/* save registers */
/*only?*/
		pushl	%eax
/*or use pushal+popal to be sure (if using C function)*/
		pushl	%ds
		pushl	%es

		/* set our descriptors up to a DATA selector */
		movl	$KERNEL_DATA, %eax
		movl	%eax, %ds
		movl	%eax, %es

		incl	ticks

		/* clear the PIC */
		movl	$0x20, %eax
		outb	%al, $0x20

/*****************************************************************************/
/*task switching test*/
//!!!!ak to bude posunute do C, ulozit vsetky registre (pushal)
		.extern irq_yes
		cmpl	$0, irq_yes
		je	endswitch	/*not ready*/
		cmpl	$2, irq_yes
		je	app

		movl	$2, irq_yes
	.extern gdt
//but what if application doesn't have GDT mapped (likely)?
//we'll have to always map it
		movb	$0x89, gdt+0x28+5	/*available 386 TSS*/
		ljmp	$0x28,$0		/*to kernel*/
		jmp	endswitch
		
	app:	movl	$1, irq_yes
		movb	$0x89, gdt+0x30+5	/*available 386 TSS*/
		ljmp	$0x30,$0		/*back to app*/

	endswitch:
/*****************************************************************************/

		/* restore registers */
		popl	%es
		popl	%ds
		popl	%eax

		iret			/* get lost */


		.data
	ticks:	.long	0		/* declare as volatile if optimizing */
