
	.text
	.global	load_idt, idt	/* export idt table and loading function */

	/* loads IDTR with kernel's Interrupt Descriptor Table */
	load_idt:
		lidt	idt48
		ret
	
/*
 *	our interrupt table stuff
 */
 		.data
		.align	8	/* for best performance (according to docs) */
	idt:			/* fill with zeroes for all 256 interrupts */
		.fill	256,8,0	/* for the format of each entry see idt.h */
		
	idt48:	/* IDT decsriptor */
		.word	(8*256)-1		/* limit (8n-1) */
		.long	idt			/* address of the table */


/*****************************************************************************/
#define SEL_ONLY	/* only selectors */
#include <asm/selector.h>
	.text
	.align 4
	.global ignore_int
ignore_int:
//	cld
	pushl %eax
	pushl %ecx
	pushl %edx
	pushl %es
	pushl %ds
	movl $KERNEL_DATA,%eax
	movl %eax,%ds
	movl %eax,%es
/*	pushl $int_msg
	call puts*/
	popl %ds
	popl %es
	popl %edx
	popl %ecx
	popl %eax
	iret
