
//n je od 0 po pages_total-1
//#define	PAGE_USED(bitmap,n)	(bitmap[(n)>>3]&(1<<((n)&0x7)))

#include <string.h>
#include <asm/types.h>
#include <asm/paging.h>
#include <kernel.h>

u32 *pd;		/* page directory */
extern void _end;	/* provided by linker, end of kernel */

void init_paging(void)
{
	u32 page_dir;

	init_pages();			/* init page bitmap for allocator */

	/* create kernel's page dir at the end of kernel, page aligned */
	if ( (page_dir = alloc_page()) == 0 ) {
		printk("PANIC! Couldn't allocate page for page directory...\nHalt");
		cli();	/* just to be sure */
		for (;;)
			;
	}

	pd = (u32 *) page_dir;
	memset((void *) pd, 0, 4096);		/* clear the directory */

	/* set up kernel page directory for the physical memory 1:1 */
///////////////////////////////////////////////////////////////////////////////
//TODO: for each mmem or mem_lower/upper?
// now it maps all pages (assuming no hole)
	for (int i=0; i<=(pages_total-1)>>10; i++) {
		u32 *pt;
		if ( (pt = (u32 *) alloc_page()) == 0 ) {
			printk("PANIC! Couldn't allocate page for page table...\nHalt");
			cli();	/* just to be sure */
			for (;;)
				;
		}
		memset((void *) pt, 0, 4096);	/* clear the table */
		/* no reason for avoiding PG_USER in directory entry */
		pd[i] = ((u32) pt) | PG_PRESENT | PG_WRITE | PG_USER;
		/* fill page table */
		for (int j=0; j < pages_total-(i<<10); j++) {
			if ( j == 1024 )	/* end of table */
				break;
			pt[j] = (i << 22) | (j << 12) | PG_PRESENT | PG_WRITE;
		}
	}
//////////////////////////////////////////////////////////////////////////

	/* set up Page Directory Base Register with our page directory */
	__asm__ __volatile__("\
			movl	%0, %%cr3		;\
			jmp	flush1			;\
		flush1:"
		: : "r" (page_dir) );

	/* enable paging */
	__asm__ __volatile__("\
			/* set most significant bit of CR0 */\
			movl	%%cr0, %%eax		;\
			orl	$0x80000000, %%eax	;\
			movl	%%eax, %%cr0		;\
			jmp	flush2			;\
		flush2:					;\
			/* jump to high memory (sets eip): */\
			movl	$paging_on, %%eax	;\
			pushl	%%eax			;\
			ret				;\
		paging_on:"
		: : : /*clobbers*/ "eax" );
}
